﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;

namespace HeuristicLab.Encodings.ScheduleEncoding {
  public interface IScheduleDecoder : IScheduleOperator {
    ILookupParameter<ISchedule> ScheduleEncodingParameter { get; }
    ILookupParameter<Schedule> ScheduleParameter { get; }
    ILookupParameter<ItemList<Job>> JobDataParameter { get; }

    Schedule DecodeSchedule(ISchedule solution, ItemList<Job> jobData);
  }

  public interface IScheduleDecoder<TSchedule> : IScheduleDecoder
    where TSchedule : class, ISchedule {
    Schedule DecodeSchedule(TSchedule solution, ItemList<Job> jobData);
  }
}
